// translated implementation of the improved perlin function http://mrl.nyu.edu/~perlin/noise/
// COPYRIGHT 2002 KEN PERLIN

#pragma once

#include "CoreMinimal.h"
#include "vector"

class PROCEDURALCITY_API PerlinNoise
{
public:
	PerlinNoise();
	PerlinNoise(unsigned int seed);
	~PerlinNoise();
	double Noise(double x);
	double Noise(double x, double y);
	double Noise(double x, double y, double z);
	double OctaveNoise(double x, int octaves, double persistence);
	double OctaveNoise(double x, int octaves, double lacunarity, double changeInAmplitude);
	double OctaveNoise(double x, double y, int octaves, double persistence);
	double OctaveNoise(double x, double y, int octaves, double lacunarity, double changeInAmplitude);
	double OctaveNoise(double x, double y, double z, int octaves, double persistence);
	double OctaveNoise(double x, double y, double z, int octaves, double lacunarity, double changeInAmplitude);

private:
	float Fade(float t);
	float Lerp(float t, float a, float b);
	float Grad(int hash, float x, float y, float z);

	std::vector<int> p;
};
