#pragma once


#include "CoreMinimal.h"
#include "StreetSegment.generated.h"

USTRUCT(BlueprintType)
struct FStreetSegment
{
	GENERATED_BODY()

	UPROPERTY(BlueprintReadWrite)
	FVector2D start;
	UPROPERTY(BlueprintReadWrite)
	FVector2D end;
	UPROPERTY(BlueprintReadWrite)
	float length;
	UPROPERTY(BlueprintReadWrite)
	bool isHighway;
	UPROPERTY(BlueprintReadWrite)
	FVector2D direction;

	FStreetSegment() {}
	FStreetSegment(FVector2D _start, FVector2D _end, bool _isHighway)
	{
		start = _start;
		end = _end;
		isHighway = _isHighway;
		direction = (end - start);
		length = direction.Size();
		direction.Normalize();
	}
};